/*
 * Copyright (C) 2003 Andrej Bagon <andrej.bagon@uni-mb.si>
 *
 * This file is part of media-box, a free multimedia system.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

#include <stdio.h>
#include <gtk/gtk.h>

#include "media-box.h"

void main_select(gint select)
{
   switch (select)
     {
      case 0:
#ifdef _DEBUG_
	printf("movie meni\n");
#endif
	if(is_dvd(DVD_DEVICE,CDROM))
	  {
	     // dvd playback...
#ifdef _DEBUG_
	     printf("lets play this dvd...\n");
#endif
	     // put background in black
	     gdk_pixbuf_fill(frame, 0x00000000); 
	     
	     meni = PLAY_MOVIE;
	     play_xine("dvd://",NULL);
	  }
	else if (is_vcd(DVD_DEVICE,CDROM))
	  {
	     // vcd playback
#ifdef _DEBUG_
	     printf("lets play this vcd...\n");
#endif
	     // put background in black
	     gdk_pixbuf_fill(frame, 0x00000000);
	     
	     meni = PLAY_MOVIE;
	     play_xine("vcd:/1",NULL);
	  }
	else
	  {
	     // no dvd play normal file
	     meni = MOVIE_MENI;
	     movie_init();
	  }
	
	break;
      case 1:
#ifdef _DEBUG_
	printf("music meni\n");
#endif
	meni = MUSIC_MENI;
	if (is_audio(CDROM_DEVICE))
	  { // audio cd
	     music_init(1);
	  }
	else
	  { // normal cd
	     mountdrive(CDROM_DEVICE, CDROM);
	     music_init(0);
	  }
	break;
      case 2:
#ifdef _DEBUG_
	printf("picture meni\n");
#endif
	meni = PICTURE_MENI;
	mountdrive(CDROM_DEVICE, CDROM);
	picture_init();
	break;
      case 3:
	gtk_main_quit();
	break;
      default:
	break;
     }
}

void main_meni (gint *select)
{
   /* circle aroud main options */
   if (*select < 0)
     *select = 3;
   if (*select >= 4)
     *select = 0;
   
   gdk_pixbuf_copy_area (background, 0, 0, back_width, back_height,
			 frame, 0, 0);
   
   put_picture(buttons[*select].x, buttons[*select].y, 21+(*select), 100);
   
   put_picture(buttons[0].x, buttons[0].y, 0, 255);
   put_picture(buttons[1].x, buttons[1].y, 1, 255);
   put_picture(buttons[2].x, buttons[2].y, 2, 255);
   put_picture(buttons[3].x, buttons[3].y, 3, 255);
   
   put_picture(main_info.title_x, main_info.title_y, 7, 255);
   put_picture(main_info.main_x, main_info.main_y, 8, 255);
   
   gtk_widget_queue_draw (da);
}

/* Expose callback for the drawing area */
gint main_expose_cb (GtkWidget *widget,
		GdkEventExpose *event,
		gpointer data)
{
   guchar *pixels;
   int rowstride;
   
   rowstride = gdk_pixbuf_get_rowstride (frame);
   
   pixels = gdk_pixbuf_get_pixels (frame) + rowstride * event->area.y + event->area.x * 3;
   gdk_draw_rgb_image_dithalign (widget->window,
				 widget->style->black_gc,
				 event->area.x, event->area.y,
				 event->area.width, event->area.height,
				 GDK_RGB_DITHER_NORMAL,
				 pixels, rowstride,
				 event->area.x, event->area.y);

   if (meni == MOVIE_MENI)
     movie_text(&menu_pos);
   
   if (meni == MUSIC_MENI)
     music_text(&menu_pos);
   
   if (meni == PICTURE_MENI)
     picture_text(&menu_pos);

   if (meni == SUB_MENI)
     sub_text(&menu_pos);
   
   return TRUE;
}

void main_init(void)
{
   if (window)
     {
	g_signal_connect (da, "expose_event",
			  G_CALLBACK (main_expose_cb), NULL);
	menu_pos = 0;
	meni = ROOT_MENI;
	main_meni( &menu_pos );
     }
}
