/*
 * Copyright (C) 2003 Andrej Bagon <andrej.bagon@uni-mb.si>
 *
 * This file is part of media-box, a free multimedia system.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <sys/types.h>

#include "media-box.h"
#include "filename.h"
#include "xine.h"

// maximum movie files listed in divx file browser
#define MAX_DISPLAY_DIVX 12

void movie_select(gint select)
{
   if (file_list[menu_pos].type == DIRECTORY_TYPE)
     {
	sprintf(cur_path,"%s",file_list[menu_pos].pathfile);
	n_files = 0;
	menu_pos = 0;
	seek_dir(cur_path, MOVIE_TYPE, file_list, &n_files);
	meni = MOVIE_MENI;
     }
   else
     {
	meni = SUB_MENI;
	prev_meni = MOVIE_MENI;
	sub_init(file_list[menu_pos].pathfile);
     }
}

void movie_play(gint select)
{
   if (file_list[menu_pos].type == DIRECTORY_TYPE)
     {
	sprintf(cur_path,"%s",file_list[menu_pos].pathfile);
	n_files = 0;
	menu_pos = 0;
	seek_dir(cur_path, MOVIE_TYPE, file_list, &n_files);
	movie_meni ( &menu_pos );
     }
   else
     {
	meni = PLAY_MOVIE;
	prev_meni = MOVIE_MENI;
	play_xine(file_list[menu_pos].pathfile,NULL);
     }
}

void fix_text(char *textin)
{
   int i,j;
   char temp[4092];
   
   j=0;
   for (i=0;i<strlen(textin);i++)
     {
	temp[j++]=textin[i];
	if (textin[i] == '&')
	  {
	     temp[j++]='a';
	     temp[j++]='m';
	     temp[j++]='p';
	     temp[j++]=';';
	  }
     }
   temp[j]='\0';
   sprintf(textin,"%s",temp);
//#ifdef _DEBUG_
//   printf("%s\n",temp);
//   printf("%s\n",textin);
//#endif
}

void movie_text(gint *select)
{
  gint i,j,k;
  PangoLayout *layout;
  char colored_text[200]; // this is bad...
   
  /* max files in the list*/
  i = MAX_DISPLAY_DIVX * (*select/MAX_DISPLAY_DIVX);
  j = i + MAX_DISPLAY_DIVX;
  
  if (j >= n_files)
     j = n_files;

  k = 0;
  for (;i<j;i++)
    {
       sprintf(colored_text,"<span font_desc=\"%s\" foreground=\"#%s\">%s</span>", font_info.name, font_info.color, file_list[i].filename);
       fix_text(colored_text);
       layout = gtk_widget_create_pango_layout(da, NULL);
       pango_layout_set_width(layout, 660000);
       pango_layout_set_wrap (layout, PANGO_WRAP_CHAR);
       pango_layout_set_spacing(layout,6500000);
       pango_layout_set_markup(layout, colored_text, -1);
       gtk_paint_layout(da->style, da->window,
			GTK_STATE_NORMAL, 1, NULL, da,
			NULL,divx_info.browser_x, divx_info.browser_y+(k*30),
			layout);
       k++;
    }
}

void movie_meni (gint *movie_select)
{
   if (*movie_select < 0)
     *movie_select = 0; 
   if (*movie_select >= (n_files - 1))
     *movie_select = n_files - 1;
   
   gdk_pixbuf_copy_area (background, 0, 0, back_width, back_height,
			 frame, 0, 0);
   
   /* divx title */
   put_picture(divx_info.title_x, divx_info.title_y, 12, 255);
   
   put_picture(20,130,37,60);
   
   /* put background on the selected movie */
   put_picture(divx_info.browser_x-20, divx_info.browser_y+(30 * (*movie_select % MAX_DISPLAY_DIVX)), 10, 100);
   
   gtk_widget_queue_draw (da);
}

void movie_init()
{
   menu_pos = 0;
   n_files = 0;
   mountdrive(CDROM_DEVICE, CDROM);
   sprintf(cur_path,"%s", CDROM);
   seek_dir(cur_path, MOVIE_TYPE, file_list, &n_files);
   movie_meni ( &menu_pos );
}
