/*
 * Copyright (C) 2003 Andrej Bagon <andrej.bagon@uni-mb.si>
 *
 * This file is part of media-box, a free multimedia system.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

#ifndef SKIN_H
#define SKIN_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_CHAR 40

struct button
{
   char base[MAX_CHAR];
   char over[MAX_CHAR];
   char down[MAX_CHAR];
   char disabled[MAX_CHAR];
   int x;
   int y;
};

struct skin
{
   char version[10];
   char name[20];
   char author[20];
};

struct mainwindow
{
   char back_image[MAX_CHAR];
   char main_image[MAX_CHAR];
   int main_x;
   int main_y;
   char title_image[MAX_CHAR];
   int title_x;
   int title_y;
   int buttons;
};

struct fonts
{
   char name[20];
   char color[20];
};

struct divx
{
   int back_x;
   int back_y;
   char back[MAX_CHAR];
   int play_x;
   int play_y;
   char play[MAX_CHAR];
   int title_x;
   int title_y;
   char title[MAX_CHAR];
   int browser_x;
   int browser_y;
   char over[MAX_CHAR];
};

struct mp3
{
   int title_x;
   int title_y;
   char title[MAX_CHAR];
   int browser_x;
   int browser_y;
   char over[MAX_CHAR];
};

struct image
{
   int title_x;
   int title_y;
   char title[MAX_CHAR];
   int browser_x;
   int browser_y;
   char over[MAX_CHAR];
};

struct skin skin_info;
struct mainwindow main_info;
struct fonts font_info;
struct button buttons[6];
struct divx divx_info;
struct mp3 mp3_info;
struct image image_info;

int get_skin_info(FILE *, struct skin *);
int get_mainwindow_info(FILE *, struct mainwindow *);
int get_fonts_info(FILE *, struct fonts *);
int get_button(FILE *, struct button *, int);
int get_divx_info(FILE *, struct divx *);
int get_mp3_info(FILE *, struct mp3 *);
int get_image_info(FILE *, struct image *);
int read_skin_config(void);
int read_line(FILE *, char *);

#endif // SKIN_H
