/*
 * Copyright (C) 2003 Andrej Bagon <andrej.bagon@uni-mb.si>
 *
 * This file is part of media-box, a free multimedia system.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <sys/types.h>

#include "media-box.h"
#include "filename.h"
#include "xine.h"

// maximum movie files listed in divx file browser
#define MAX_DISPLAY_DIVX 12

gchar movie_to_play[PATH_MAX];
struct files sub_list[100];
gint n_subs;

void sub_select(gint select)
{
   if (sub_list[menu_pos].type == DIRECTORY_TYPE)
     {
	sprintf(cur_path,"%s",sub_list[menu_pos].pathfile);
	n_subs = 1;
	menu_pos = 0;
	sprintf(sub_list[0].filename,"No subtitle");
	sub_list[0].type=2;
	seek_dir(cur_path, SUB_TYPE, sub_list, &n_subs);
	sub_meni(&menu_pos);
     }
   else
     {
	meni = PLAY_MOVIE;
	prev_meni = MOVIE_MENI;
	
	// background in black
	gdk_pixbuf_fill(frame, 0x00000000);
	
	play_xine(movie_to_play,sub_list[menu_pos].pathfile);
     }
}

void sub_text(gint *select)
{
  gint i,j,k;
  PangoLayout *layout;
  char colored_text[200]; // this is bad...
   
  /* max files in the list*/
  i = MAX_DISPLAY_DIVX * (*select/MAX_DISPLAY_DIVX);
  j = i + MAX_DISPLAY_DIVX;
  
  if (j >= n_subs)
     j = n_subs;

  k = 0;
  for (;i<j;i++)
    {
       sprintf(colored_text,"<span font_desc=\"%s\" foreground=\"#%s\">%s</span>", font_info.name, font_info.color, sub_list[i].filename);
       fix_text(colored_text);
       layout = gtk_widget_create_pango_layout(da, NULL);
       pango_layout_set_width(layout, 660000);
       pango_layout_set_wrap (layout, PANGO_WRAP_CHAR);
       pango_layout_set_spacing(layout,6500000);
       pango_layout_set_markup(layout, colored_text, -1);
       gtk_paint_layout(da->style, da->window,
			GTK_STATE_NORMAL, 1, NULL, da,
			NULL,divx_info.browser_x,divx_info.browser_y+(k*30),
			layout);
       k++;
    }
}

void sub_meni (gint *movie_select)
{
//  gint x,y;

  if (*movie_select < 0)
    *movie_select = 0; 
  if (*movie_select >= (n_subs - 1))
    *movie_select = n_subs - 1;

  gdk_pixbuf_copy_area (background, 0, 0, back_width, back_height,
  			frame, 0, 0);
  
  /* divx title */
  put_picture(divx_info.title_x, divx_info.title_y, 12, 255);
  /* movie label */
//  put_picture(divx_info.media_x, divx_info.media_y, 13, 255);

  /* play and back button */
//  put_picture(divx_info.play_x, divx_info.play_y, 11, 254);
//  put_picture(divx_info.back_x, divx_info.back_y, 9, 254);
  
   put_picture(20,130,37,60);
   
  /* scrollers and arrows for movie files*/
  // get divx over text width
//  x = gdk_pixbuf_get_width(images[10]);
//  put_picture(divx_info.media_browser_x + x + gdk_pixbuf_get_width(images[16]), divx_info.media_browser_y, 15, 255);
  /* slider is displayed in divx_movie_slider()
  put_picture(720, 142, 17, 255);
  */

//  if (n_files != 0)
    {
      /* put background on the selected movie */
      put_picture(divx_info.browser_x-20,divx_info.browser_y+(30 * (*movie_select % MAX_DISPLAY_DIVX)), 10, 100);
       
      // put here the moving slider for movies
/*      y = 0;
      if (n_files != 0)
	y = (*movie_select) * gdk_pixbuf_get_height(images[15]) / n_files; 
      printf("%dx%d\n",x,y);
      put_picture(divx_info.media_browser_x + x, divx_info.media_browser_y + y, 16, 255);
*/
      /* display text on window */
      /* NO NEED BECAUSE I DRAW IN REPAINT FUNCTION */
//      divx_text(movie_select);
      /* divx_sub_text(sub_select); */ 
    }

  gtk_widget_queue_draw (da);
}

void sub_init(char *movie_file)
{
   menu_pos = 0;
   n_subs = 1;
   sprintf(movie_to_play,"%s",movie_file);
   sprintf(sub_list[0].filename,"No subtitle");
   sub_list[0].type=2;
//   mountdrive(CDROM_DEVICE, CDROM);
//   sprintf(cur_path,"%s", CDROM);
   seek_dir(cur_path, SUB_TYPE, sub_list, &n_subs);
   movie_meni ( &menu_pos );
}
